*( INF_ENG.CMD--R:BASE expert system inference engine.)
SET MESSAGES OFF ; SET ERROR MESSAGES OFF ; CLS
DECLARE c1 CURSOR FOR SELECT object FROM objects
OPEN c1
FETCH c1 INTO obvar
DECLARE c2 CURSOR FOR SELECT has_it, quality +
  FROM rule_base WHERE object=.obvar ORDER BY ask_order
WHILE SQLCODE <> 100 THEN
  OPEN c2
  FETCH c2 INTO hasvar, qvar
  WHILE SQLCODE <> 100 AND qvar IS NOT NULL THEN
    SET VAR newvar TEXT = (.qvar & '(Y/N): ')
    SELECT * INTO dummy FROM pos_facts +
      WHERE quality = .qvar
    IF SQLCODE = 100 THEN
      SELECT * INTO dummy FROM neg_facts +
        WHERE quality = .qvar
      IF SQLCODE = 100 THEN
        *( No match between the rule segment and the stored)
        *( facts, so consult the user for a new observation fact.)
        SET VAR uresp = 'X'
        WHILE uresp <> 'Y' +
          AND uresp <> 'N' THEN
          FILLIN uresp=0 USING .newvar
        ENDWHILE
        IF uresp = 'Y' AND hasvar = 1 THEN
          *( The object has the quality and the user observes it,)
          *( so fetch the next rule segment.)
          INSERT INTO pos_facts VALUES (.qvar)
          SET VAR uresp = NULL
          FETCH c2 INTO hasvar, qvar
        ENDIF
        IF uresp = 'N' AND hasvar = 0 THEN
          *( The object doesn't have the quality and the user)
          *( observes that, so fetch the next rule segment)
          INSERT INTO neg_facts VALUES (.qvar)
          SET VAR uresp = NULL
          FETCH c2 INTO hasvar, qvar
        ENDIF
        IF uresp = 'Y' AND hasvar = 0 THEN
          *( The object has the quality, but the user doesn't)
          *( observe it.)
          INSERT INTO pos_facts VALUES (.qvar)
          SET VAR qvar = NULL
        ENDIF
        IF uresp = 'N' AND hasvar = 1 THEN
          *( The object doesn't have the quality even though)
          *( the user observes it.)
          INSERT INTO neg_facts VALUES (.qvar)
          SET VAR qvar = NULL
        ENDIF
      ELSE
        IF hasvar = 0 THEN
          *( The quality exists in NEG_FACTS and)
          *( HAS_IT is equal to 0, so fetch the next rule.)
          FETCH c2 INTO hasvar, qvar
        ELSE
          SET VAR qvar = NULL
        ENDIF
      ENDIF
    ELSE
      IF hasvar = 1 THEN
        *( The quality exists in POS_FACTS and HAS_IT)
        *( is equal to 1, so fetch the next rule segment.)
        FETCH c2 INTO hasvar, qvar
      ELSE
        SET VAR qvar = NULL
      ENDIF
    ENDIF
  ENDWHILE
  IF qvar IS NOT NULL OR SQLCODE = 100 THEN
    *( All of the rule segments for an object have been)
    *( successfully matched with the stored facts.)
    WRITE ' '
    SET VAR outvar TEXT = ('it may be a(n)' & .obvar + '.')
    WRITE .outvar
    *( Explain how result was obtained.)
    SET HEADINGS OFF
    WRITE ' '
    WRITE 'This result was obtained from these supplied facts.'
    WRITE 'You answered affirmatively to these questions.'
    SELECT * FROM pos_facts
    WRITE 'Press a key to continue...' ; PAUSE
    WRITE 'You answered negatively to these questions.'
    SELECT * FROM neg_facts
    WRITE 'Press a key to continue...' ; PAUSE
    BREAK
  ENDIF
  CLOSE c2
  FETCH c1 INTO obvar
ENDWHILE
IF qvar IS NULL THEN
  *( All objects have failed in matching all of their rule )
  *( segments with the stored facts.)
  WRITE ' '
  WRITE 'Unable to determine what animal this is.'
ENDIF
CLEAR VAR obvar, hasvar, qvar, newvar, uresp DELETE FROM pos_facts
DELETE FROM neg_facts
DROP CURSOR c1
DROP CURSOR c2
SET MESSAGES ON ; SET ERROR MESSAGES ON
SET HEADINGS ON

